You're viewing an archived version of our docs. Check out our current documentation →
Guides / Building Search UI

How to install Vue InstantSearch

Install Vue InstantSearch with a packaging system or with a direct link in your web page.

With a packaging system

If you have a JavaScript build tool (for example if you’ve created your project using the Vue command-line tool), you can install Vue InstantSearch from npm:

1
npm install algoliasearch vue-instantsearch

Then in your main js file, you can load the package as Vue plugin:

1
2
3
4
5
6
7
import { createApp } from 'vue';
import App from './App.vue';
import InstantSearch from 'vue-instantsearch/vue3/es';

const app = createApp(App);
app.use(InstantSearch);
app.mount('#app');

This lets you use all the widgets directly in your components.

Directly in your page

Vue works when you’re embedding it directly in an HTML page too. First add the two script tags:

1
2
3
4
5
6
7
<script src="https://cdn.jsdelivr.net/npm/algoliasearch@5.38.0/dist/lite/builds/browser.umd.js" integrity="sha256-vQ8Q6Q2c9VMfNmP3MX1VE/L7ebwZZC+eD9KnJMNG8I4=" crossorigin="anonymous"></script>

<!-- For Vue 2: -->
<script src="https://cdn.jsdelivr.net/npm/vue-instantsearch@4.21.3/vue2/umd/index.js" integrity="sha256-oSL2GYFFMTuSk9IvRAvVsL4vwIRGvxCQwdOMb8kH/QY=" crossorigin="anonymous"></script>

<!-- For Vue 3: -->
<script src="https://cdn.jsdelivr.net/npm/vue-instantsearch@4.21.3/vue3/umd/index.js" integrity="sha256-n3juXhdpYTT9tZuAuvTqA7TJ1Gjw0zN2hLsTJ7mT9uo=" crossorigin="anonymous"></script>

Then you can write your Vue app within your HTML, for example in a #app div.

1
2
3
4
<!-- Replace INDEX_NAME with the name of your index. -->
<ais-instant-search index-name="INDEX_NAME" v-bind:search-client="searchClient">
  <!-- Regular Vue InstantSearch app here -->
</ais-instant-search>

Finally, add a script tag with the instantiation of the plugin and the app:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
<script>
  const { liteClient: algoliasearch } = window['algoliasearch/lite'];
  const { createApp } = Vue;

  const app = createApp({
    data() {
      return {
        // Initialize the search client
        
        //  If you're logged into the Algolia dashboard, the following values for
        //  YourApplicationID and YourSearchOnlyAPIKey are auto-selected from
        //  the currently selected Algolia application.
        searchClient: algoliasearch(
          'YourApplicationID',
          'YourSearchOnlyAPIKey'
        ),
      };
    },
  });
  app.use(VueInstantSearch);
  app.mount('#app');
</script>

ais-instant-search is the root Vue InstantSearch component. All widgets must be wrapped within it

In a production environment, secure your API keys as environment variables.

Send click and conversion events

Capturing real-time user interactions as events gives you actionable insights via click and conversion metrics, and they help you increase your customer engagement and conversions. Events are used to activate Algolia features and products like NeuralSearch, Dynamic Re-Ranking, Query Categorization, Recommend, and Personalization.

To send click and conversion events when users interact with your search UI, set the insights option to true.

Optimize your build with tree shaking

Tree shaking can be done with modern build tools. The goal is to have code that’s actually used in your built site. In the context of Vue InstantSearch this means not including the widgets that aren’t used. You can do this by using the components directly, rather than the Vue.use(InstantSearch) call.

In every component you’re using InstantSearch widgets, you can import and instantiate them like this:

1
2
3
4
5
6
7
8
import { AisInstantSearch, AisSearchBox } from 'vue-instantsearch/vue3/es';

export default {
  components: {
    AisInstantSearch,
    AisSearchBox,
  },
};

The build tool you’re using will then be able to only include the widgets that you’re actually using.

Browser support

Algolia supports the last two versions of the major browsers: Chrome, Edge, Firefox, Safari.

To support Internet Explorer 11 you need polyfills for: Array.prototype.find, Array.prototype.includes, Promise, Object.entries, and Object.assign.

The code samples in this documentation use a JavaScript syntax that isn’t natively supported by older browsers like Internet Explorer 11. If your site needs to support older browsers, use a tool like Babel to make your code work in the browsers you target.

You're viewing an archived version of our docs. Check out our current documentation →
Guides / Building Search UI

How to install React InstantSearch

This is the React InstantSearch v7 documentation. React InstantSearch v7 is the latest version of React InstantSearch and the stable version of React InstantSearch Hooks.

If you were using React InstantSearch v6, you can upgrade to v7.

If you were using React InstantSearch Hooks, you can still use the React InstantSearch v7 documentation, but you should check the upgrade guide for necessary changes.

If you want to keep using React InstantSearch v6, you can find the archived documentation.

Install React InstantSearch as an npm package or include it in your app with a CDN link.

React InstantSearch is composed of two separate packages:

  • react-instantsearch which exposes all UI widgets and re-exports all Hooks.
  • react-instantsearch-core which only exposes all Hooks. You only need this package if you’re using React InstantSearch with React Native.

The code examples on this page use the React InstantSearch library with the algoliasearch/lite client, which is smaller but doesn’t support indexing your data. To perform indexing operations, import the regular algoliasearch client.

Install React InstantSearch as an npm package

If you’re using a package manager and a build tool, you can install React InstantSearch from npm:

1
2
3
npm install algoliasearch react-instantsearch
# or
yarn add algoliasearch react-instantsearch

Then in your app, import the module:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
import React from 'react';
{/* Import React InstantSearch */}
import { liteClient as algoliasearch } from 'algoliasearch/lite';
import { InstantSearch } from 'react-instantsearch';

{/*
  Initialize the search client

  If you're logged into the Algolia dashboard, the following values for
  YourApplicationID and YourSearchOnlyAPIKey are auto-selected from
  the currently selected Algolia application.
*/}
const searchClient = algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey');

function App() {
  return (
    {/*
      Render the React InstantSearch wrapper.
      Replace INDEX_NAME with the name of your index.
    */}
    <InstantSearch searchClient={searchClient} indexName="INDEX_NAME">
      {/* Add widgets here */}
    </InstantSearch>
  );
}

<InstantSearch> is the root React InstantSearch component. All widgets must be wrapped within it

In a production environment, secure your API keys as environment variables.

Include React InstantSearch with a CDN

If you don’t use a package manager and a build tool, you can include React InstantSearch directly from the jsDelivr CDN.

1
2
3
4
5
6
7
8
9
10
<script
  src="https://cdn.jsdelivr.net/npm/algoliasearch@5.38.0/dist/lite/builds/browser.umd.js"
  integrity="sha256-vQ8Q6Q2c9VMfNmP3MX1VE/L7ebwZZC+eD9KnJMNG8I4="
  crossorigin="anonymous"
></script>
<script
  src="https://cdn.jsdelivr.net/npm/react-instantsearch@7.16.3/dist/umd/ReactInstantSearch.min.js"
  integrity="sha256-hPyyNcmoXT+UgWCThzfpGcQonGeCfxMpOOcPxKEccf8="
  crossorigin="anonymous"
></script>

jsDelivr is a third-party CDN. Algolia can’t provide support for such third-party services.

You now have access to the ReactInstantSearch object on the global window object.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
const { liteClient: algoliasearch } = window['algoliasearch/lite'];
const { InstantSearch } = ReactInstantSearch;

{/*
  Initialize the search client

  If you're logged into the Algolia dashboard, the following values for
  YourApplicationID and YourSearchOnlyAPIKey are auto-selected from
  the currently selected Algolia application.
*/}

const searchClient = algoliasearch('YourApplicationID', 'YourSearchOnlyAPIKey');

function App() {
  return (
    {/*
      Render the React InstantSearch wrapper.
      Replace INDEX_NAME with the name of your index.
    */}
    <InstantSearch searchClient={searchClient} indexName="INDEX_NAME">
      {/* Add widgets here */}
    </InstantSearch>
  );
}

<InstantSearch> is the root React InstantSearch component. All widgets must be wrapped within it.

In a production environment, you should secure your API keys as environment variables.

Send click and conversion events

Capturing real-time user interactions as events gives you actionable insights via click and conversion metrics, and they help you increase your customer engagement and conversions. Events are used to activate Algolia features and products like NeuralSearch, Dynamic Re-Ranking, Query Categorization, Recommend, and Personalization.

To send click and conversion events when users interact with your search UI, set the insights option to true.

TypeScript support

These packages ship with TypeScript types:

  • react-instantsearch (v7)
  • react-instantsearch-core (v7)

The following packages don’t ship with TypeScript types, but have DefinitelyTyped definitions you can use:

  • react-instantsearch (v6)
  • react-instantsearch-core (v6)
  • react-instantsearch-dom (v6)
  • react-instantsearch-native (v6)

If you have issues when using them, contact the DefinitelyTyped community.

The react-instantsearch-dom-maps package doesn’t ship with TypeScript types and doesn’t have any DefinitelyTyped definitions.

Browser support

Algolia supports the last two versions of the major browsers: Chrome, Edge, Firefox, Safari.

To support Internet Explorer 11 you need polyfills for: Array.prototype.find, Array.prototype.includes, Promise, Object.entries, and Object.assign.

The code samples in this documentation use a JavaScript syntax that isn’t natively supported by older browsers like Internet Explorer 11. If your site needs to support older browsers, use a tool like Babel to make your code work in the browsers you target.